package com.school.project.model.marks;


import com.fasterxml.jackson.annotation.JsonIgnore;
import com.school.project.model.Course;
import com.sun.istack.NotNull;
import lombok.Getter;
import lombok.Setter;
import org.springframework.security.config.annotation.method.configuration.EnableMethodSecurity;

import javax.persistence.*;
import java.util.List;
import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "assessment")
public class Assessment {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    @Column(name = "assessment_id")
    private Long assessmentId;

    @ManyToOne
    @JoinColumn(name = "assessment_type_id")
    @NotNull
    private AssessmentType assessmentType;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinTable(name = "course_assessments",
    joinColumns = {@JoinColumn(name = "assessment_id")},
    inverseJoinColumns = {@JoinColumn(name = "course_id")})
    @NotNull
    @JsonIgnore
    private Course course;


    @OneToMany(mappedBy = "assessment",fetch = FetchType.LAZY)
    @JsonIgnore
    private List<Section> section;
}
